#
# lxc: linux Container library
#
# (C) Copyright IBM Corp. 2007, 2008
#
# Authors:
# Daniel Lezcano <dlezcano at fr.ibm.com>
#
# This library is free software; you can redistribute it and/or
# modify it under the terms of the GNU Lesser General Public
# License as published by the Free Software Foundation; either
# version 2.1 of the License, or (at your option) any later version.
#
# This library is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# Lesser General Public License for more details.
#
# You should have received a copy of the GNU Lesser General Public
# License along with this library; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA

Name: lxc
Version: 0.8.0
Release: 2.0.8%{?dist}
URL: http://lxc.sourceforge.net
Source: http://dl.sourceforge.net/sourceforge/%{name}/%{name}-%{version}.tar.gz
Summary: %{name} : Linux Container
Group: Applications/System
License: LGPL
BuildRoot: %{_tmppath}/%{name}-%{version}-build
Requires: compat-db43 libcap libvirt openssl rsync
BuildRequires: libcap libcap-devel docbook-utils automake autoconf

Patch0001: 0001-dont-fail-on-failure-to-link-kmsg.patch
Patch0002: 0002-ensure-btrfs-subvolume-is-removed-when-container-cre.patch
Patch0003: 0010-Add-oracle-template.patch
Patch0009: 0020-Fix-checkconfig-to-handle-kernel-memory-cgroup-name-.patch
Patch0010: 0022-Create-busybox-commands-as-symlinks-instead-of-hardl.patch
Patch0011: 0023-lxc-clone-use-hardlink-detection-in-rsync.patch
Patch0012: 0024-templates-use-hardlink-detection-in-rsync.patch
Patch0013: 0025-make-install-should-create-LXCPATH-directory.patch
Patch0015: 0027-Use-LXCPATH-and-LOCALSTATEDIR-instead-of-hardcoded-v.patch
Patch0016: 0028-make-install-should-create-var-cache-lxc-directory.patch
Patch0018: 0030-lxc.spec-add-openssl-and-rsync-as-Required-since-bot.patch
Patch0019: 0031-Don-t-attempt-to-symlink-kmsg-without-rootfs-path.patch
Patch0020: 0040-Fix-race-corruption-with-multiple-lxc-start-lxc-exec.patch
Patch0022: 0050-lxc-destroy-container-only-if-it-is-in-the-STOPPED-s.patch
Patch0023: 0051-fix-lxc-wait-waiting-forever-for-FREEZING-FROZEN-THA.patch
Patch0024: 0052-separate-console-device-from-console-log.patch
Patch0026: 0061-document-lxc-console-escape-sequence-and-argument.patch
Patch0027: 0062-legacy-ls-only-output-appropriate-directories-contai.patch

%description

The package "%{name}" provides the command lines to create and manage
containers.  It contains a full featured container with the isolation
/ virtualization of the pids, the ipc, the utsname, the mount points,
/proc, /sys, the network and it takes into account the control groups.
It is very light, flexible, and provides a set of tools around the
container like the monitoring with asynchronous events notification,
or the freeze of the container. This package is useful to create
Virtual Private Server, or to run isolated applications like bash or
sshd.

%package        libs
Summary:        runtime library files for %{name}
Group:          System Environment/Libraries

%description    libs
The %{name}-libs package contains libraries for running %{name} applications.

%package devel
Summary: development library for %{name}
Group: Development/Libraries

%description devel
The %{name}-devel package contains header files and library needed for
development of the linux containers.

%prep
%setup
%patch0001 -p1
%patch0002 -p1
%patch0003 -p1
%patch0009 -p1
%patch0010 -p1
%patch0011 -p1
%patch0012 -p1
%patch0013 -p1
%patch0015 -p1
%patch0016 -p1
%patch0018 -F3 -p1
%patch0019 -p1
%patch0020 -p1
%patch0022 -p1
%patch0023 -p1
%patch0024 -p1
%patch0026 -p1
%patch0027 -p1
%build
PATH=$PATH:/usr/sbin:/sbin %configure $args --disable-rpath --with-config-path=/container --disable-apparmor
make %{?_smp_mflags}

%install
rm -rf %{buildroot}
make install DESTDIR=%{buildroot}
find %{buildroot} -type f -name '*.la' -exec rm -f {} ';'

%clean
rm -rf %{buildroot}

%post

%files
%defattr(-,root,root)
%{_bindir}/*
%attr(4111,root,root) %{_bindir}/lxc-attach
%attr(4111,root,root) %{_bindir}/lxc-create
%attr(4111,root,root) %{_bindir}/lxc-clone
%attr(4111,root,root) %{_bindir}/lxc-shutdown
%attr(4111,root,root) %{_bindir}/lxc-start
%attr(4111,root,root) %{_bindir}/lxc-netstat
%attr(4111,root,root) %{_bindir}/lxc-unshare
%attr(4111,root,root) %{_bindir}/lxc-execute
%attr(4111,root,root) %{_bindir}/lxc-checkpoint
%attr(4111,root,root) %{_bindir}/lxc-restart
%{_mandir}/*
%{_datadir}/doc/*
%{_datadir}/lxc/*

%files libs
%defattr(-,root,root)
%{_libdir}/*.so.*
%{_libdir}/%{name}
%attr(4555,root,root) %{_libexecdir}/%{name}/lxc-init

%files devel
%defattr(-,root,root)
%{_includedir}/%{name}/*
%{_libdir}/*.so
%{_libdir}/pkgconfig/*

%changelog
* Thu Feb 14 2013 Dwight Engen <dwight.engen@oracle.com> - Version 0.8.0-2.0.8
- orabug 16324116 handle 5.latest correctly in redo_pkgs
- fix commenting out of "Remounting rootfs" in rc.sysinit

* Wed Feb 13 2013 Dwight Engen <dwight.engen@oracle.com> - Version 0.8.0-2.0.7
- use libvirt for rpm Requires not libvirt-daemon

* Tue Feb 12 2013 Dwight Engen <dwight.engen@oracle.com> - Version 0.8.0-2.0.6
- orabug 16297177 default to same release as host
- orabug 16297404 add libvirt-daemon and compat-db43 as rpm Requires
- orabug 16297950 set selinux labels on devices created by oracle template
- orabug 16302675 don't attempt to remount / (superficial error message)
- orabug 16303282 don't attempt to unmount swap in container halt
- orabug 16304447 bad copy when using oracle templatefs -t option
- orabug 16316699 lxc-ls returning non-container directories

* Fri Feb 08 2013 Dwight Engen <dwight.engen@oracle.com> - Version 0.8.0-2.0.5
- merge all oracle template patches into one, update to latest to handle
  ol4 better and handle some selinux cases
- fix orabug 16296667 due to misapplied patch in lxc-shutdown
- remove distro config /etc/lxc/lxc.conf patch since it is not needed and
  the name is changing in 0.9.0

* Wed Jan 09 2013 Dwight Engen <dwight.engen@oracle.com> - Version 0.8.0-2.0.4
- fix orabug 16010534 prevent insmod, rmmod (git d378aebe)
- fix orabug 16071473 document <Ctrl-a q> to escape lxc-console (git 76848789)
- fix orabug 16090880 lxc-shutdown not working

* Fri Dec 28 2012 Dwight Engen <dwight.engen@oracle.com> - Version 0.8.0-2.0.3
- add fixes for orabugs 15984742, 15989848
- fix creation of busybox based containers

* Fri Dec 14 2012 Dwight Engen <dwight.engen@oracle.com> - Version 0.8.0-2.0.2
- add fixes for orabugs 15984921, 15972116, use with OVM template rootfs
- add support for creating ol4 container from ovm template

* Tue Dec  4 2012 Dwight Engen <dwight.engen@oracle.com> - Version 0.8.0-2.0.1
- Add autoconf, automake to BuildRequires since patch0001 modifies configure.ac,
  and if the build files are not regenerated the Oracle template will not be
  included.
  
* Wed Nov 21 2012 Dwight Engen <dwight.engen@oracle.com> - Version 0.8.0-2
- include oracle template
- set container directory to /container

* Mon Sep 10 2012 Dwight Engen <dwight.engen@oracle.com> - Version 0.8.0
- fix lxc-init moved to libexec
- .pc moved to _libdir
- package template files /usr/share/lxc/templates

* Thu Sep  8 2011 Greg Kurz <gkurz@fr.ibm.com> - Version 0.7.5.1
- fix installed files for rpmbuild
- introduce lxc-libs package

* Fri Jul 23 2010 Daniel Lezcano <dlezcano@fr.ibm.com> - Version 0.7.2
- set attribute for installed files
- fix libraries installation

* Mon Mar 24 2009 Daniel Lezcano <daniel.lezcano@free.fr> - Version 0.6.1
- Removed capability setting, let the user to do that through "lxc-setcap"

* Mon Feb 16 2009 Daniel Lezcano <daniel.lezcano@free.fr> - Version 0.6.0
- Added more capabilities to the executables

* Sun Jan 25 2009 Daniel Lezcano <daniel.lezcano@free.fr> - Version 0.6.0
- Reduced spec file

* Sun Aug 3 2008 Daniel Lezcano <dlezcano@fr.ibm.com> - Version 0.1.0
- Initial RPM release.

# Local variables:
# mode: shell-script
# sh-shell: rpm
# end:
